class SPK_BlasterHardpoint extends SPK_Hardpoint;

Var ParticleSystemComponent FireParticles;
Var SoundCue FireCue;
Var Class<Actor> ProjectileClass;
Var Vector FireDirection;

Event PostBeginPlay()
{

	Local SPK_Ship Creator;

	Super.PostBeginPlay();

	Creator = SPK_Ship( Owner );

	if( Creator != None )
	{

		Creator.HardpointsFirePrimary[ Creator.HardpointsFirePrimary.Length ] = Self;

	}

}

function Trigger( SPK_HardpointEvent Reason )
{

	Local Actor Spawned;
	Local SPK_PathProjectile Affix;
	Local SPK_Ship Creator;
    Local Vector XAxis, YAxis, ZAxis;

	Switch( Reason )
	{

		case SPK_HARDPOINTEVENT_FIREPRIMARY:

			FireParticles.ActivateSystem();
			PlaySound( FireCue );

			Spawned = Spawn( ProjectileClass, Owner );

			Affix = SPK_PathProjectile( Spawned );

			if( Affix != None )
			{

				Creator = SPK_Ship( Owner );

				if( Creator != None )
				{

                    GetAxes( Rotation, XAxis, YAxis, ZAxis );

					Affix.AttachedTo = Creator.AttachedTo;
					Affix.Progress = Creator.Progress;
					If( Creator.Ambush ) Affix.SetVelocity( FireDirection ); Else Affix.SetVelocity( FireDirection * Vect( -1.0f, 1.0f, 1.0f ) );
                    Affix.Progress = Affix.AttachedTo.Progress( Affix.Progress, YAxis Dot Offset );
                    Affix.Strafe = Creator.Strafe - ( XAxis Dot Offset );

				}

			}

		break;

        Default:

            Super.Trigger( Reason );

        Break;

	}

}

defaultproperties
{

    FireDirection = ( X = 1.0f, Y = 0.0f, Z = 0.0f );

	Begin Object Class=ParticleSystemComponent Name=ParticleSystemComponent0

		Template = ParticleSystem'SPK_Hardpoints.bLast';
		bAutoActivate = False;

	End Object

	FireParticles = ParticleSystemComponent0;

	Components.Add( ParticleSystemComponent0 );

	FireCue = SoundCue'SPK_Hardpoints.Blast_Long';
	ProjectileClass = Class'SPK_BlasterProjectile';

}
