Class SPK_EnvironmentJunk Extends SPK_EnvironmentActor;

Var Bool bDetonated;

Var ParticleSystemComponent ExplosionEmitter;
Var Bool HasTicked;

Event Touch( Actor Other, PrimitiveComponent OtherComponent, Vector HitLocation, Vector HitNormal )
{

    If( HasTicked )
    {

        If( !bDetonated )
        {

            If( ( SPK_EnvironmentActor( Other ) != None ) || ( SPK_PathObject( Other ) != None ) )
            {

                bDetonated = True;
                ExplosionEmitter.ActivateSystem();
                DetachComponent( Mesh );
                Mesh = None;

                If( SPK_Ship( Other ) != None ){ SPK_Ship( Other ).CauseDamage( 5, Location ); }

            }

        }

    }

}

Event Tick( Float FrameDelta )
{

    If( bDetonated )
    {

        If( ExplosionEmitter.bWasCompleted ) Destroy();

    }

    HasTicked = True;

    Super.Tick( FrameDelta );

}

DefaultProperties
{

    bDetonated = False;
    HasTicked = False;

    Begin Object Class=ParticleSystemComponent Name=DestructionEmitter

        bAutoActivate = False;

    End Object

    Components.Add( DestructionEmitter );

    ExplosionEmitter = DestructionEmitter;

    Begin Object Name=DisplayMesh

        CollideActors = True;

    End Object

    bWander = True;
    bSpin = True;

    bSpawnOnTrack = True;

    bCollideActors = True;

}
