Class SPK_EnvironmentNebula Extends SPK_EnvironmentActor;

Var Bool bUsesParticlePrefix;
Var String ParticlePrefix;
Var ParticleSystem ParticleNoPrefix;

Var ParticleSystemComponent Gas;

Event PostBeginPlay()
{

	Local ParticleSystem ToUse;

	ToUse = GetParticle();

	If( ToUse == None ) `Warn( Self$" failed to choose a particle system." ); Else
	{

		Gas.SetTemplate( ToUse );

	}

    If( bWander ) WanderSpeed = ( ( VRand() * 2.0f ) - Vect( 1.0f, 1.0f, 1.0f ) ) * WanderLimit;

    If( bSpin )
    {

        SpinSpeed.Pitch = Lerp( -SpinLimit, SpinLimit, FRand() );
        SpinSpeed.Yaw = Lerp( -SpinLimit, SpinLimit, FRand() );
        SpinSpeed.Roll = Lerp( -SpinLimit, SpinLimit, FRand() );

    }

}

Function ParticleSystem GetParticle()
{

	Local String Reference;

	If( bUsesParticlePrefix )
	{

		Reference = "ParticleSystem'"$ParticlePrefix$"_"$( SuffixMin + Rand( SuffixMax - SuffixMin ) )$"'";

		Return ParticleSystem( DynamicLoadObject( Reference, Class'ParticleSystem', False ) );

	}

	Return ParticleNoPrefix;

}

DefaultProperties
{

    Radius = 64.0f;

    Remove Object DisplayMesh;

    Begin Object Class=ParticleSystemComponent Name=GasEmitter

        bAutoActivate = True;

    End Object

    Components.Add( GasEmitter );

    Gas = GasEmitter;

    SuffixMin = 0;
    SuffixMax = 4;
    ParticlePrefix = "SPK_Environment.Nebulae";
    ParticleNoPrefix = None;
    bUsesParticlePrefix = True;

    ZOffset = -1024.0f;

    DrawScale = 4.0f;

}
