class SPK_FreeProjectile extends Actor;

var Vector ProjectileVelocity;
var Float Thrust, Damping, InitialThrust;

event Tick( float FrameDelta )
{

	ProjectileVelocity *= Damping ** FrameDelta;
	ProjectileVelocity += Normal( ProjectileVelocity ) * Thrust;

	SetLocation( Location + ( ProjectileVelocity * FrameDelta ) );

}

function SetVelocity( vector Direction )
{

	ProjectileVelocity = Normal( Direction ) * InitialThrust;
	SetRotation( Rotator( Direction ) );

}

defaultproperties
{

	ProjectileVelocity = ( X = 0.0f, Y = 0.0f, Z = 0.0f );
	Thrust = 1.0f;
	InitialThrust = 1.0f;
	Damping = 1.0f;

}