Class SPK_MenuHUD Extends SPK_HUD;

Var GFxMoviePlayer Menu;
Var GFxObject PlayKey, QuitKey;
Var Int MenuSelection;

Simulated Event PostBeginPlay()
{

	Menu = New Class'GFxMoviePlayer';

	If( Menu != None )
	{

		Menu.MovieInfo = SwfMovie'SPK_UI.Title';
		Menu.SetTimingMode( TM_Real );
		Menu.SetAlignment( Align_BottomLeft );
		Menu.Start();
		Menu.Advance( 0.0f );

        PlayKey = Menu.GetVariableObject( "_root.PlayKey" );
        QuitKey = Menu.GetVariableObject( "_root.QuitKey" );

	}

}

Singular Event Destroyed()
{

	If( Menu != None ) Menu.Close();

	Super.Destroyed();

}

Event PostRender()
{

	Local Int UIScale;

	UIScale = Canvas.SizeY / 2;

    If( PressedUp || PressedDown ) MenuSelection = 1 - MenuSelection;

    If( PressedSelect ) If( MenuSelection == 0 ) WorldInfo.ServerTravel( "SPK_Space" ); Else ConsoleCommand( "Exit" );

	If( Menu != None )
	{

        If( MenuSelection == 0 )
        {

            PlayKey.SetVisible( True );
            QuitKey.SetVisible( False );

        }
        Else
        {

            PlayKey.SetVisible( False );
            QuitKey.SetVisible( True );

        }

		Menu.SetViewport( 0, Canvas.SizeY - UIScale, UIScale, UIScale );

	}

    Super.PostRender();

}

DefaultProperties
{

    MenuSelection = 0;

}
