class SPK_PlayerController extends PlayerController;

Var SPK_Ship Control;
Var SPK_Camera View;
Var SPK_Path Path;
Var SPK_Game Game;
Var SPK_PathProgress RespawnPoint;

Function PlayerDied( SPK_PathProgress Progress )
{

    Local SPK_GameHUD Notify;

    Notify = SPK_GameHUD( MyHUD );

    If( Game.GetStateName() == 'Finishing' ) Control.Health = 0; Else
    {

        If( Game.Lives <= 0 )
        {

            If( Notify != None ) Notify.Message = Notify.AddClip( SWFMovie'SPK_UI.Failure', Align_BottomLeft, False );

            Game.GotoState( 'Finished' );

        }
        Else
        {

            Game.Lives--;
            SetTimer( 2.0f, False, 'RespawnTimer' );
            Control = None;
            Game.PlayerShip = None;
            View.SkipFrame = True;
            View.Track = None;
            RespawnPoint = Progress;

        }

    }

}

Function RespawnTimer()
{

    Control = Path.Spawn( Game.PlayerShipType, Self );

    If( Control == None ) `Warn( "Could not spawn replacement player ship." ); else
    {

        Control.AttachToPath( Path, Path.Vertices[ 0 ], 0.0f );
        Control.Progress = RespawnPoint;
        Game.PlayerShip = Control;
        View.Track = Control;

    }

}

Simulated Event PostBeginPlay()
{

	Local SPK_Path Search;

	Super.PostBeginPlay();

	Game = None;
	Path = None;

	Game = SPK_Game( WorldInfo.Game );

	ForEach AllActors( class'SPK_Path', Search ) { Path = Search; }

	if( Game == None ) `Log( "Error: Gametype is not a SPK_Game derivative." ); else
	{

		if( Path == None ) `Log( "Error: Could not find the path in the game world." ); else
		{

			if( Path.Vertices.Length < 1 ) `Log( "Error: Path has no vertices." ); else
			{

				Control = Path.Spawn( Game.PlayerShipType, Self );

				if( Control == None ) `Log( "Error: Could not spawn player's ship." ); else
				{

					Control.AttachToPath( Path, Path.Vertices[ 0 ], 0.0f );

					View = Path.Spawn( class'SPK_Camera' );

					if( View == None )
					{

						`Log( "Error: Could not spawn the camera." );

						Control.Destroy();

					}
					else
					{

						View.Track = Control;
						SetViewTarget( View );

                        Game.PlayerShip = Control;

					}

				}

			}

		}

	}

}

Exec Function GoPause()
{

    Local SPK_HUD Inform;

    Inform = SPK_HUD( MyHUD );

    If( Inform != None ) Inform.PressedCancel = True;

}

Exec Function GoSelect()
{

    Local SPK_HUD Inform;

    Inform = SPK_HUD( MyHUD );

    If( Inform != None ) Inform.PressedSelect = True;

}

Exec Function GoLeft()
{

    Local SPK_HUD Inform;

    Inform = SPK_HUD( MyHUD );

    If( Inform != None ) Inform.PressedUp = True;

	if( Control != None ) Control.GoLeft();

}

Exec Function GoRight()
{

    Local SPK_HUD Inform;

    Inform = SPK_HUD( MyHUD );

    If( Inform != None ) Inform.PressedDown = True;

	if( Control != None ) Control.GoRight();

}

Exec Function GoForwards()
{

	if( Control != None ) Control.GoForwards();

}

Exec Function GoBackwards()
{

	if( Control != None ) Control.GoBackwards();

}

Exec Function StopLeft()
{

	if( Control != None ) Control.StopLeft();

}

Exec Function StopRight()
{

	if( Control != None ) Control.StopRight();

}

Exec Function StopForwards()
{

	if( Control != None ) Control.StopForwards();

}

Exec Function StopBackwards()
{

	if( Control != None ) Control.StopBackwards();

}

Exec Function FirePrimary()
{

	if( Control != None ) Control.FirePrimary();

}

Exec Function CeasePrimary()
{

	if( Control != None ) Control.CeasePrimary();

}

Exec Function FireSecondary()
{

	if( Control != None ) Control.FireSecondary();

}

defaultproperties
{

	Control = None;

}
