Class SPK_SwooperShip Extends SPK_Ship;

Enum SPK_SwooperShipMode
{

    SS_SSM_INITIAL,
    SS_SSM_SWOOPRIGHT,
    SS_SSM_SWOOPLEFT,
    SS_SSM_WAITLEFT,
    SS_SSM_WAITRIGHT

};

Var SPK_SwooperShipMode Mode;

Event PostBeginPlay()
{

    AddHardpoint( Class'SPK_EngineHardpoint', Vect( -15.033f, -6.66f, 0.036f ) );
    AddHardpoint( Class'SPK_EngineHardpoint', Vect( -15.033f, 6.66f, 0.036f ) );
    AddHardpoint( Class'SPK_BlasterHardpoint', Vect( 13.853f, -34.016f, -0.96f ) );
    AddHardpoint( Class'SPK_BlasterHardpoint', Vect( 13.853f, 34.016f, -0.96f ) );

    Super.PostBeginPlay();

}

Function SwoopWait()
{

    Switch( Mode )
    {

        Case SS_SSM_INITIAL:

        Break;

        Case SS_SSM_SWOOPRIGHT:

        Break;

        Case SS_SSM_SWOOPLEFT:

        Break;

        Case SS_SSM_WAITLEFT:

            Mode = SS_SSM_SWOOPRIGHT;
            GoRight();

        Break;

        Case SS_SSM_WAITRIGHT:

            Mode = SS_SSM_SWOOPLEFT;
            GoLeft();

        Break;

    }

    FirePrimary();

}

Event Tick( Float FrameDelta )
{

    Switch( Mode )
    {

        Case SS_SSM_INITIAL:

            If( Strafe > 0.0f )
            {

                GoLeft();
                Mode = SS_SSM_SWOOPLEFT;

            }
            Else
            {

                GoRight();
                Mode = SS_SSM_SWOOPRIGHT;

            }

        Break;

        Case SS_SSM_SWOOPRIGHT:

            If( Strafe < -72.0f )
            {

                Mode = SS_SSM_WAITRIGHT;
                SetTimer( 1.0f, False, 'SwoopWait' );
                CeasePrimary();

            }

        Break;

        Case SS_SSM_SWOOPLEFT:

            If( Strafe > 72.0f )
            {

                Mode = SS_SSM_WAITLEFT;
                SetTimer( 1.0f, False, 'SwoopWait' );
                CeasePrimary();

            }


        Break;

        Case SS_SSM_WAITLEFT:

        Break;

        Case SS_SSM_WAITRIGHT:

        Break;

    }

    Super.Tick( FrameDelta );

}

DefaultProperties
{

    Mode = SS_SSM_INITIAL;

    Begin Object Name=StaticMeshComponent0

        StaticMesh = StaticMesh'SPK_Ships.Swooper.Swooper';

    End Object

    StrafeSpeed = 128.0f;
    SpeedNormal = 80.0f;
    Health = 10;

    CollisionMass = 1.1f;

    KillScore = 200;

}
