class SPK_TurretHardpoint extends SPK_BlasterHardpoint;

Var Bool HasLOS;
Var StaticMeshComponent Turret;

Event PostBeginPlay()
{

	Local SPK_Ship Creator;

	Super.PostBeginPlay();

	Creator = SPK_Ship( Owner );

	if( Creator != None )
	{

		Creator.HardpointsTick[ Creator.HardpointsTick.Length ] = Self;

	}

}

Function Trigger( SPK_HardpointEvent Reason )
{

	Local SPK_Ship Creator, Iterate;
    Local Vector TargetXYZ, XAxis, YAxis, ZAxis;
    Local SPK_Game Game;
    Local Float Shortest, ThisDist;

	Switch( Reason )
	{

		case SPK_HARDPOINTEVENT_TICK:

            Creator = SPK_Ship( Owner );

            if( Creator != None )
            {

                Game = SPK_Game( WorldInfo.Game );

                If( Game != None )
                {

                    If( Game.PlayerShip != None )
                    {

                        GetAxes( Owner.Rotation, XAxis, YAxis, ZAxis );

                        /* Aim right ahead if there are no valid targets. */
                        TargetXYZ = Location + ( Offset.X * XAxis ) + ( Offset.Y * YAxis ) + ( Offset.Z * ZAxis );

                        If( Game.PlayerShip == Creator )
                        {

                            /* Find the closest ship. */
                            HasLOS = False;

                            /* Can't find a definition of FLOAT_MAX. */
                            Shortest = 100000.0f;

                            /* This is far from efficient, there might be a better way to do this. */
                            ForEach AllActors( Class'SPK_Ship', Iterate )
                            {

                                If( Iterate != Creator )
                                {

                                    If( ( Normal( ( Offset.X * XAxis ) + ( Offset.Y * YAxis ) + ( Offset.Z * ZAxis ) ) Dot Normal( Iterate.Location - Location ) ) > -0.25f )
                                    {

                                        ThisDist = VSize( Location - Iterate.Location );

                                        If( ThisDist < Shortest )
                                        {

                                            TargetXYZ = Iterate.Location;

                                            Shortest = ThisDist;

                                            HasLOS = True;

                                        }

                                    }

                                }

                            }

                        }
                        Else
                        {

                            If( ( Normal( ( Offset.X * XAxis ) + ( Offset.Y * YAxis ) + ( Offset.Z * ZAxis ) ) Dot Normal( Game.PlayerShip.Location - Location ) ) > -0.25f )
                            {

                                TargetXYZ = Game.PlayerShip.Location;
                                HasLOS = True;

                            } Else HasLOS = False;

                        }

                        Turret.SetRotation( Rotator( ( TargetXYZ - Location ) * Vect( 1.0f, 1.0f, 0.0f ) ) );
                        FireDirection = Vector( Rotator( Normal( Location - TargetXYZ ) ) - Owner.Rotation ) * Vect( -1.0f, -1.0f, 0.0f );

                    }

                }

            }

            Super.Trigger( Reason );

		break;

        Case SPK_HARDPOINTEVENT_FIREPRIMARY:

            If( HasLOS ) Super.Trigger( Reason );

        Break;

        Default:

            Super.Trigger( Reason );

        Break;

	}

}

defaultproperties
{

    HasLOS = False;

    Begin Object Class=StaticMeshComponent Name=TurretBody

		StaticMesh = StaticMesh'SPK_Ships.Battleship.Battleship_Turret';

    End Object

    Components.Add( TurretBody );

    Turret = TurretBody;

	FireCue = SoundCue'SPK_Hardpoints.Blast_Medium';
	ProjectileClass = Class'SPK_TurretProjectile';

}
